Garland(CF-767C)

Problem Description

Once at New Year Dima had a dream in which he was presented a fairy garland. A garland is a set of lamps, some pairs of which are connected by wires. Dima remembered that each two lamps in the garland were connected directly or indirectly via some wires. Furthermore, the number of wires was exactly one less than the number of lamps.

There was something unusual about the garland. Each lamp had its own brightness which depended on the temperature of the lamp. Temperatures could be positive, negative or zero. Dima has two friends, so he decided to share the garland with them. He wants to cut two different wires so that the garland breaks up into three parts. Each part of the garland should shine equally, i. e. the sums of lamps' temperatures should be equal in each of the parts. Of course, each of the parts should be non-empty, i. e. each part should contain at least one lamp.

Garland(CF-767C)_第1张图片

Help Dima to find a suitable way to cut the garland, or determine that this is impossible.

While examining the garland, Dima lifted it up holding by one of the lamps. Thus, each of the lamps, except the one he is holding by, is now hanging on some wire. So, you should print two lamp ids as the answer which denote that Dima should cut the wires these
 lamps are hanging on. Of course, the lamp Dima is holding the garland by can't be included in the answer.

Input

The first line contains single integer n (3 ≤ n ≤ 106) —
 the number of lamps in the garland.

Then n lines follow. The i-th
 of them contain the information about the i-th lamp: the number lamp ai,
 it is hanging on (and 0, if is there is no such lamp), and its temperature ti ( - 100 ≤ ti ≤ 100).
 The lamps are numbered from 1 to n.

Output

If there is no solution, print -1.

Otherwise print two integers — the indexes of the lamps which mean Dima should cut the wires they are hanging on. If there are multiple answers, print any of them.

Examples

Input

6
2 4
0 5
4 2
2 1
1 1
4 2

Output

1 4

Input

6
2 4
0 6
4 2
2 1
1 1
4 2

Output

-1

Note

The garland and cuts scheme for the first example:

Garland(CF-767C)_第2张图片

题意:给定一颗二叉树,问从哪两个地方剪可以使余下的三部分的节点和都相等

思路:由于总和固定,因此每一颗子树的点权是固定的,设每一部分的大小为 W,从下往上更新,遇到等于 W 的子树就切,次数重置成 0,这样就可以一边遍历子树,一边算次数,需要注意一条链的情况与三的倍数但不能分成几个相等的部分的情况。

Source Program

#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#define INF 0x3f3f3f3f
#define PI acos(-1.0)
#define N 1000001
#define MOD 10007
#define E 1e-6
#define LL long long
using namespace std;
vector son[N];
int pre[N],temp[N];
int cnt[N],num[2];
int sum,root;
int k,t;
int treeDP(int x){
    int y=son[x].size();//记录儿子数
    if(y==0){//如果儿子数为0
        cnt[x]=temp[x];
        if(temp[x]==t&&x!=root)
		{
			num[k++]=x;
			return 0;
		}
		return temp[x];
    }
    for(int i=0;i>n;
    for(int i=1;i<=n;i++){
        int x,y;
        cin>>x>>y;
        son[x].push_back(i);//存储关系
        sum+=y;//记录总和
        pre[i]=x;//记录前驱
        temp[i]=y;
        if(x==0)//寻找根节点
            root=i;
    }

    if(sum%3){//如果不能整除
        cout<<-1<

 

你可能感兴趣的:(#,CodeForces,动态规划——树形,DP)